\section{Notes from Chapter 4: Architecture}
	\paragraph{Tile architecture} The Knights Landing tile (Figure \ref{fig:tiledetail}) is the basic unit that gets replicated across de chip. It consists in two cores, each core is connected to two vector processing units (VPUs), and shared 1 M L2 cache. (p. 63)
	
	The VPU is the heart of computation on Knights Landing. It is home to all the floating-point (FP) compute capability. Each core is connected to two VPU units and hence can execute 512-bit vector multiply-add instructions per cycle. Thus, each core can deliver 32 double-precision (DP) or 64 single-precision (SP) FP operations each cycle. (p. 63)

	The L2 cache is 1 MB in capacity with 16-way associativity  with 64B cache lines that is shared between both cores in the same tile. The L2 cache supports a bandwidth of 1 cache line read and $\rfrac{1}{2}$ cache line write per cycle, which is shared by both cores in the tile. The bus interface unit (BUI) controls the L2 cache and coherency between the two cores in the tile. One core can use all the available read and write bandwidth if the other core is not accessing the L2. The L2 cache is private tile, which means multiples tiles reading the same cache line will have their own private copy in their respective L2 cache. However, all L2 caches are coherent; a write operation to a cache line from one tile will invalidate all other copies of that line in the other tiles. (p. 63-65)
	
	\begin{figure}[htbp]
		\centering
		\includegraphics[width=0.7\linewidth]{figuras/tile_detail}
		\caption{Connection within a tile between cores, BUI, L2 and CHA.}
		\label{fig:tiledetail}
	\end{figure}

	The cache coherency is across all L2 caches is enforced by a distributed directory MESIF protocol that tracks the cache lines present inside all the tiles in Modified, Exclusive, Shared, Invalid or Forward state. (p. 65)
	
	\paragraph{Core and VPU} List of changes from the low-power Intel Atom: (p. 65)
	\begin{itemize}
		\item Added four threads per core to provide higher-throughput performance.
		\item More than doubled the number of the inflight instructions, that is, the Reorder Buffer (ROB) size to 72 slots, to imprive the single thread performance.
		\item Added vector instructions (AVX, AVX-2, AVX-512) support.
		\item Added two VPUs to the main out-of-order pipeline.
		\item Increased size of the L1 data cache (DL1) to 32 KB to match de DL1 size in the Knights Corner.
		\item Added two 64B loads ports in the DL1 to feed the two VPUs.
		\item Increased sizes for TLBs and added 1 GB page support.
		\item Implemented gather/scatter engine to insert the gather loads and scatter stores without consuming fetch and decode slots in the pipeline.
		\item Added support to complete quickly the accesses that are unaligned or split across multiple cache-lines.
		\item Doubled the L2 cache bandwidth to 1 cache line read and $\rfrac{1}{2}$ cache line write per cycle.
	\end{itemize}

	In the Figure \ref{fig:corevpu} is shown the block diagram of the Knights Landing core and VPU. It is divided into five units: (p.65)
	
	\begin{enumerate}
		\item Front-End Unit (FEU).
		\item Allocation Unit (AU).
		\item Integer Execution Unit (IEU).
		\item Memory Execution Unit (MEU).
		\item Vector Processing Unit (VPU).
	\end{enumerate}


	\begin{figure}[htbp]
		\centering
		\includegraphics[width=\linewidth]{figuras/core_vpu}
		\caption{Knights Landing core micro-architecture.}
		\label{fig:corevpu}
	\end{figure}


	\paragraph{Front-End Unit} Is the responsible for fetching the instructions, decoding them, predicting branches, breaking instructions into simpler micro-operations and delivering them to the AU. Converting instructions into micro-operations allows handling complex instructions without building complex hardware. (p. 66)
	
	The process begins with the next instruction pointer block sending the next instruction to be fetched to the Instruction Cache (Icache). There is a thread selector at this point which decides which thread to pick for the next instruction fetch. Instruction bytes are read from the 32 KB, 8-way associative, Icache and written in an intermediate buffer. In parallel, the 48-entry Instruction TLB (ITLB) is accesed to obtain virtual to physical address translation. The thread is stalled in case of Icache or ITLB miss until the miss is recovered and other threads are selected for instruction fetch. (p. 68)
	
	Instructions are selected from the intermediate buffer for decode. An intelligent thread selector ensures that instructions for all active threads are selected in a fair manner, while taking into account the ability of that thread to make forward progress. Up to two instructions can be decoded each cycle. If an instruction is a complex instruction, then the Microcode ROM is accessed to obtain the corresponding micro-operation for that instruction. Eventually, up to two micro-operations are written per cycle in the Instruction Queue (IQ). (p. 68)
	
	\paragraph{Allocation Unit} The AU is responsible for preparing micro-operations for out-of-order execution. It assigns the necessary pipeline resources required by the micro-operations, such as ROB entries, Rename Buffer (RB) entries, Store Data buffers, gather/scatter table entries and Reservation Station (RS) entries. It also renames the logical register sources and destinations in the micro-operations to the RB entries. The RB provides storage for inflight operations until they retire, at which time these results are transferred to the architectural Register File (RF). After assigning the required pipeline resources and the remaining registers, the AU sends the micro-operations to one of the three execution units, Integer, Memory, or Vector Processing, based on their type. (p. 68)
	
	The AU is 2-wide, meaning it operates on two micro-operations every cycle. It reads two micro-operations from the Instruction Queue every cycle. A thread selector decides which thread is read from the IQ. The micro-operations that do not have all the resources they need in order to proceed are stalled in the allocation until those resources become available. This does not prevent other threads, which may have available resources, from proceeding. The thread selector take stalls into account when reading micro-operations from the IQ. This ensures we keep the downstream pipeline busy while some threads may be blocked for resources in AU. (p. 68)
	
	The AU writes up to two micro-operations in Integer, FP or Memory RS per cycle. (p. 68)
	
	\paragraph{Integer Execution Unit} The IEU executes integer micro-operations, which are defined as those that operate with general purpose registers R0-R15. There are two IEU in the core. Each IEU contains 12-entry RS that issues one micro-operation per cycle. Most operations have 1-cycle latency and are supported by the both IEUs, but a few operations have 3- or 5-cycle latency and are only supported by one of the IEUs. (p. 69)
	
	\paragraph{Memory Execution Unit} The MEU executes memory micro-operations and services fetch requests for Icache misses and ITLB misses. Up to two memory operations, either a load or a store, can be executed in the MEU per cycle. Memory operations are issued in-order from 12-entry memory RS, but they can execute and complete out-of-order. The micro-operations that were not able to complete successfully are placed into the Recycle Buffer and reissued to the MEU pipe once their conflict conditions are resolved. Completed loads are kept in the memory queue, to maintain consistency, until they are retired. While stores are kept in the store buffer after address translation, they can forward data to any dependent loads. Stores are committed to the memory in the program order, one per cycle. (p. 69)
	
	The MEU supports unaligned memory access without any penalties and supports accesses that are split across two cache lines with a two-cycles penalty. The fast unaligned and cache split accesses help workload where memory accesses may not always be aligned to natural data type sized boundaries. (p. 69)
	
	The MEU contains specialized logic to handle gather and scatter instructions efficiently. A single gather/scatter instruction can access multiple memory locations. In Knights Landing, such multiple accesses are generated by a special engine close to the L1 cache pipeline, instead of being a series of micro-operations that flow though the entire core pipeline. This allows for executing gather and scatter instructions while consuming minimal resources in rest of the core, allowing other types of micro-operations to make forward progress in parallel. (p. 69)
	
	\paragraph{Vector Processing Unit} The VPU is the vector and the FP arithmetic execution unit of Knights Landing and is responsible of providing for support SSE, AVX, AVX-512 instructions, as well as integer divides. There are two VPUs connected to the core. These are tightly integrated into the pipeline, with the AU dispatching instructions directly into the VPUs. The VPUs are mostly symmetrical, and each is able to provide a steady-state throughput of one AVX-512 instruction per cycle, providing a peak of 64 SP or 32 DP FP operations per cycle from the pair of VPUs available per core (i.e., 2 VPUs per core, 1 AVX-512 instruction per cycle per VPU, FMA offers 16 DP or 32 SP FP operations per instruction using AVX-512 registers that are 8 DP or 16 SP wide, $2 \times 1 \times 16 = 32$ DP or $2 \times 1 \times 32 = 64$ SP). One of the VPUs is extended to provide support for the legacy FP instructions. (p. 69-70)
	
	Each VPU contains a 20-entry FP operation RSs that issues out-of-order one micro-operation per cycle. The FP RS are different from the IEU RS and the MEU RS in that they, to help reduce their size, do not hold source data; the FP micro-operations read the source data from de FP RB and FP RF after they issue from the FP RS, spending an extra cycle between RS and the execution compared to the integer and memory micro-operations. Most FP arithmetic operations have a latency of six-cycles, while other arithmetic operations have a latency of two or three cycles, depending on the operation type. (p. 70)
	
	
	\paragraph{Threading} The core supports four threads of execution. These are implemented as hyperthreads where the instructions from all threads flow through the pipeline simultaneously. Thread-selection points in the pipeline select from which thread instruction move forward. This decision is made each cycle and takes into accounts such factors as thread fairness, instruction availability, thread-specific stalls and other constraints, to help maximize the utilization of the hardware. (p. 70)
	
	Structures are shared by threads, dynamically partitioned among them, or replicated for each thread. Dynamically partitioned structures readjust their partitions as threads go to sleep or are awoken so that the active threads get to use the full physical structure. For example, when one thread is active, the thread will use the 72 entries in the ROB. However, when two threads are active, then each thread will use 36 entries, and when three or four entries are active, each thread will use 18 entries. Shared resources do not enforce partitioning; threads get shared resources on first-come-first-served basis. Replicated resources have dedicated copies for each thread, irrespective of whether they are active or not. Very few structures in the core are replicated by thread. (p. 70)
	
	Threading can be turned off with the BIOS settings, in which case there will be only one thread per core. In many cases, unlike Knights Corner, a single active thread is sufficient to utilize all the core resources. Using two active threads is often the best general choice as the out-of-order processing can often hide instruction and cache access latencies for many workloads. Four active threads per core can provide additional significant benefit for memory latency sensitive workloads and for applications with strong thread scaling and datasets that do not increase per thread. (p. 70)
	
	\paragraph{Cluster modes} Cluster modes are the way to divide the chip into separate virtual regions with the intention of keeping the on-die communications to be as local as possible. The goal is to lower latency and increase the bandwidth of on-die communications. We support three primary cluster modes:
	
	\begin{itemize}
		\item All-to-all mode.
		\item Quadrant mode.
		\item Sub-NUMA Cluster (SNC) mode.
	\end{itemize}

	The only issue is performance; software will run in any cluster mode, and cache-coherency is always maintained across the entirety of a Knights Landing. (p.71)
	
	These modes can be best understood by observing how the data flow required to service an L2 cache miss would vary between the different modes. A typical L2 miss is show in Figure \ref{fig:alltoall} (which is also the figure that describes all-to-all cluster mode). There are three main agents that participate in an L2 miss flow:
	
	\begin{enumerate}
		\item The tile that generates the miss.
		\item The tag directory (as part of CHA) that ``owns'' the missing address and tracks whether any other tile on the chip has that address on its caches.
		\item The memory that supplies the data for servicing the miss. 
	\end{enumerate}

	On a L2 miss, the tile sends the request to the CHA to check if any other tile on the chip has that address in its caches. If the CHA finds that no other tile has the address cached then it sends the request to the memory. The memory reads the data and sends it to the requesting tile. If the CHA finds that other tile has the data in its caches, then it will send the request to that tile to send the data to the tile that had the miss. The three cluster modes create different levels of ``affinity'' between the three agents to localize the communication between them. (p. 72)

	\begin{figure}[htbp]
		\centering
		\includegraphics[width=1\linewidth]{figuras/all-to-all}
		\caption{An L2 cache miss flow example in all-to-all cluster mode.}
		\label{fig:alltoall}
	\end{figure}

	\paragraph{All-to-all cluster mode} Is the most general among all three modes. This mode can be lowest at overall performance than the other cluster modes, but it can be used with any DDR DIMM configuration. It is the only mode that can be used when DDR DIMMs are not identical in capacity. In this mode there is no affinity between the tile, the CHA and the memory. The addresses are uniformly hashed across all CHAs and over all memory, independently. Any tile may request data at an address that is tracked by a CHA at any part of the chip, and the memory location may reside in any part of the chip. A L2 miss transaction will traverse longer distances, on average, across the chip to get the data in all-to-all mode. (p. 72)
	
	The purpose of this mode is to offer flexibility in supporting any combination of allowed DDR DIMM configurations. This mode can route physical addresses from any tile of the CHA, to any memory controller. While not the default, this mode is automatically chosen in the event of any memory asymmetries or other configuration irregularities are detected in the system at boot time. (p. 72)
	
	\paragraph{Quadrant cluster mode} The quadrant mode (Figure \ref{fig:quadrant}) will be the mode in which most software will want to run. This mode is expected to be the default mode of the BIOS although all-to-all mode will be entered if DDR DIMMs are not found to be identical in capacity. This mode is transparent to the software, in that software does not need to take any specific actions to benefit from this mode. In this mode, we establish affinity between the two of the three agents, that is, the CHA and the memory. The chip is divided into four virtual quadrants. The memory addresses are hashed such that the CHA that has the tag directory for a memory address is in the same quadrant as the memory where data for the addresses resides. This way a memory access transaction travels locally within the same quadrant after checking the tag directory in the CHA to reach the memory. This reduces the latency of memory accesses compared to all-to-all mode. Since reduced latency allows hardware buffers involved in memory access translations to be freed sooner, the quadrant mode allows more memory transactions to occur in a given time; therefore it offers higher bandwidth than all-to-all mode. (p.73)
	
	The only requirement for using the quadrant mode is that the memory configuration be symmetric, that is all the DDR DIMMs be of the same capacity. This is needed for the address hashing to work to enable the quadrant division. Once booted in quadrant mode, software does not need to do anything special to benefit from this mode. (p. 73)
	
	\begin{figure}[htbp]
		\centering
		\includegraphics[width=1\linewidth]{figuras/quadrant}
		\caption{An L2 cache miss flow example in quadrant cluster mode.}
		\label{fig:quadrant}
	\end{figure}


	\paragraph{SNC-4 mode} The SNC mode (Figure \ref{fig:snc}) provides the lowest latency and most localized communications among all the sides. It extends the two-agent affinity in the quadrant mode to three-agent affinity which includes all three agents: the tile, the CHA, and the memory. (p. 73)
	
	In this mode, each quadrant is exposed as a separate cache-coherent NUMA cluster that is visible to the operating system, via BIOS ACPI tables. The memory addresses are distributed such that a continuous region of memory is mapped to each cluster and the tag directories for memory addresses mapped in a cluster are in CHAs that are also all within the same cluster. (p. 73)
	
	A NUMA-optimized software will see all its memory access transactions complete locally so that they will stay entirely within the same cluster. Such memory accesses from a tile will go to a CHA that is in the same cluster and, thereafter, will go to a memory which is in the same cluster. This local communication enables shortest communication latencies in this mode. As with quadrant mode, SNC-4 mode enable higher bandwidths due to better utilization of the hardware buffers that support memory transactions resulting in higher bandwidth than all-to-all and quadrant mode. (p. 74)
	
	Unlike all-to-all and quadrant mode , this mode is not entirely software transparent. The software needs to be NUMA optimized to benefit from from this mode. The only issue is performance; software will work in any cluster mode including SNC. However, software that is not NUMA optimized is most likely to run better in quadrant mode. (p. 74)


	\begin{figure}[htbp]
		\centering
		\includegraphics[width=1\linewidth]{figuras/snc}
		\caption{An L2 cache miss flow example in SNC cluster mode.}
		\label{fig:snc}
	\end{figure}

	\paragraph{Memory Interleaving} Memory interleaving is a technique to spread out consecutive memory access across multiple channels, in order to parallelize the accesses to increase effective bandwidth. The interleaving granularity is always a cache line, which is a 64 bytes for Knights Landing. (p. 76)
	
	In all-to-all, quadrant and hemisphere modes, addresses are uniformly distributed across the memory channels. The distribution pattern is different for each mode as it depends on the specific hash function used to assign memory addresses to different CHAs. The net effect is that the addresses are uniformly distributed across the memory channels. In flat memory modes contiguous ranges of memory are assigned to DDR and MCDRAM, respectively, with the MCDRAM range above the DDR range. The addresses in the DDR range are uniformly distributed among the DDR channels, while the addresses in the MCDRAM memory range are uniformly distributed among the MCDRAM channels. In cache memory mode, since only DDR memory is visible to software, the entire memory range is distributed among the DDR channels. The address distribution in hybrid mode is similar to the distribution patterns in flat mode and cache memory mode for the address ranges that are mapped as flat and cache, respectively. (p. 77)
	
	In SNC-2 and SNC-4 cluster modes, contiguous regions of the memory are assigned to each cluster (also a NUMA mode) and are cache line interleaved among the memory channels with that NUMA mode, respectively. In flat memory mode, the memory region mapped to each SNC cluster is divided into two contiguous portions, one of MCDRAM and other for DDR. These portions are interleaved over the MCDRAM and other for the DDR channels that are in that cluster (for SNC-4, since DDR channels are not entirely within a cluster, the interleaving is over all the three channels that are closer to the cluster; this looks similar to SNC-2). In cache memory mode, the addresses are interleaved over the DDR channels, since MCDRAM is a cache and is hidden behind the memory. In hybrid mode the addresses interleaving will be similar to flat and cache mode based on whether the memory region is mapped to flat or cache portion of the memory. (p. 78)
	
	\paragraph{Memory modes} Knights Landing supports three memory modes for configuring the MCDRAM and DDR memory: cache mode, flat mode and hybrid mode. In cache mode, memory is configured as a cache for the DDR memory; in flat mode, MCDRAM is configured as a memory just like DDR and is part of the same space address; and in hybrid mode, a portiond of the MCDRAM is configured as a cache and the remainder is configured as flat in the same space address as DDR. Like cluster modes, the memory modes are also selected at boot time via BIOS options and can be only set once during boot time. The memory mode cannot be changed again until the next system reset. (p. 79)
	
	\paragraph{Cache mode} In cache mode, MCDRAM is configured as a cache for the DDR memory. The MCDRAM cache is completely hardware managed, requiring no software enablement. Legacy, unmodified software can use this mode and benefit from the high bandwidth provided by MCDRAM. The benefits will, of course, depend on the hit rate observed by the software. (p. 79)
	
	MCDRAM cache is a direct mapped cache with 64-byte cache lines. The tags are stored in the MCDRAM, as part of extra bits available in each cache line. These extra bits are read at the same time as the cache line, thereby allowing tag and data to be read on the same access, and hence, enabling the determination of a hit or miss in cache without needing a separate read access. Since MCDRAM size is much larger than traditional caches, in most cases there should be no significant change in conflict misses due to direct-mapped policy. (p. 80)
	
	In this mode all request first go to the MCDRAM for a cache lookup and then, in case of a miss, a request is sent to DDR. The memory accesses will never bypass the MCDRAM to go to the DDR. On a miss, the data is read from the DDR and sent to the MCDRAM, to fill the cache, and the requesting tile, respectively. (p. 80)
	
	MCDRAM cache is a memory-sided cache, as opposed to the CPU-sided caches such as L1, L2 or last levels caches, in that a memory side cache is closer to the memory in terms of properties as compared to the CPU-sided caches on the cores or tiles. It acts more like a high bandwidth buffer sitting on the way to memory, exhibiting memory semantics, instead of a cache sitting closer to the cores. Unlike caches on the cores or the tiles, the MCDRAM cache does not need to be snooped by external transactions since any access to memory goes first through the MCDRAM cache. An ``uncacheable'' memory type that does not allocate in core cache will allocate in the MCDRAM cache, since MCDRAM cache is but a part of memory, just higher bandwidth. (p. 80)
	
	MCDRAM cache is made inclusive of all modified lines of L2 caches. In other words, if a cache line resides in a modified state in an L2 cache, it musts also be in MCDRAM. This ensures that when a modified line is written back from a L2 cache, there is no need to query the MCDRAM cache first before writing the line into it. There is no risk of overwriting a different line, since with the modified-inclusive property, the line being written back is guaranteed to be present in the MCDRAM cache. To maintain this modified-inclusive property, before a line is evicted from MCDRAM, a snoop is sent to check if a modified copy of that line exists in L2 cache and, if so, downgrade it from modified to shared by forcing a writeback of the modified line. The line gets no evicted from the cache. (p. 80)
	
	As mentioned before, the MCDRAM cache mode is completely transparent to software and will work out of the box on unmodified code. The benefits derived from the MCDRAM cache will depend on the hit rate seen by software. This cache works well for many applications, but for applications that do not show good hit rates in the MCDRAM, the two other memory modes provide more control for applications to directly manage their use of MCDRAM. (p. 80)
	
	\paragraph{Flat mode} In flat mode, both MCDRAM and DDR are presented as regular memory mapped in the same system address space. There is no difference between MCDRAM region and DDR region in terms of semantics; both act as regular load/store memory. Unlike cache mode, flat mode is not software transparent. The software needs to explicitly allocate best suited data in the MCDRAM for it to benefit from the provided high bandwidth. However, once data is allocated in MCDRAM, software will see stable high bandwidth access to that data, since there is no dependency on ``hit'' rate like in cache mode. (p. 80)
	
	There are two modes that are degenerate forms of the flat mode: MCDRAM-only mode and DDR-only mode. In these cases there are only one type of memory present in the system, that is, MCDRAM or DDR, but not both. Since these modes are similar to standard systems with one type of memory, no software modification is needed; programs will run by allocating all their memory in MCDRAM or DDR, whichever is available. (p. 81)
	
	\paragraph{Hybrid mode} The hybrid mode, as the name suggests, is a combination of the cache mode and the flat mode. A portion of the MCDRAM is configured as cache (25\% or 50\%) and the remaining is configured as flat memory (75\% and 50\%). This is ideal for applications that benefit from general caching and can also take advantage of high bandwidth memory by storing critical or frequently accessed data in flat memory.
	
	\paragraph{Interactions of cluster and memory modes} See Figure \ref{fig:clustermodes}.
	
	\begin{figure}[htbp]
		\centering
		\includegraphics[width=1\linewidth]{figuras/cluster_modes}
		\caption{Memory and cluster combinations, assuming systems with MCDRAM and DDR both.}
		\label{fig:clustermodes}
	\end{figure}
	
	
